// RRMfcTwoWaysDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RRMfcTwoWays.h"
#include "RRMfcTwoWaysDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// declare things for subclassing
LPCSTR subclassname = _T("myapplication.superclass");
static void StopSubClassing(HWND hWnd);
LRESULT CALLBACK mySubClasshandler(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);
void startSubClassing(HWND hWnd, WNDPROC proc);


/////////////////////////////////////////////////////////////////////////////
// CRRMfcTwoWaysDlg dialog

CRRMfcTwoWaysDlg::CRRMfcTwoWaysDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRRMfcTwoWaysDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRRMfcTwoWaysDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRRMfcTwoWaysDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRRMfcTwoWaysDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRRMfcTwoWaysDlg, CDialog)
	//{{AFX_MSG_MAP(CRRMfcTwoWaysDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_FLIPP, OnButtonFlipp)
	ON_BN_CLICKED(IDC_BUTTON_SHOW, OnButtonShow)
	ON_BN_CLICKED(IDC_BUTTON_HIDE, OnButtonHide)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRRMfcTwoWaysDlg message handlers

BOOL CRRMfcTwoWaysDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	try{   
		//start subclassing
		// pass the subclasser the handle of the dialog window
		startSubClassing(m_hWnd, mySubClasshandler);
		// tell the server to whom he should send his messages
		m_App->SetPeer((long)m_hWnd);
	}
	catch (_com_error & e){
			AfxMessageBox(e.Description());
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRRMfcTwoWaysDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRRMfcTwoWaysDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
// here we talk with our server

void CRRMfcTwoWaysDlg::OnButtonFlipp() 
{
	if(m_App){
		m_App->FlippIt();
	}
	
}

void CRRMfcTwoWaysDlg::OnButtonShow() 
{
	if(m_App){
		m_App->Show(0);
	}
	
}

void CRRMfcTwoWaysDlg::OnButtonHide() 
{
	if(m_App){
		m_App->Hide();
	}
	
}

BOOL CRRMfcTwoWaysDlg::DestroyWindow() 
{
	try{   
		StopSubClassing(m_hWnd);
	}
	catch (_com_error & e){
			AfxMessageBox(e.Description());
	}
	
	return CDialog::DestroyWindow();
}

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
// here subclass the current window, and react on messages received 
// from our server

void startSubClassing(HWND hWnd, WNDPROC proc)
{
  WNDPROC old = (WNDPROC)GetWindowLong(hWnd, GWL_WNDPROC);
  SetWindowLong(hWnd, GWL_WNDPROC, (LONG)proc);
  SetProp(hWnd, subclassname, (HANDLE) old);
}

static void StopSubClassing(HWND hWnd)
{
  SetWindowLong(hWnd, GWL_WNDPROC, (LONG)GetProp(hWnd, subclassname));
  RemoveProp(hWnd, subclassname);
}


LRESULT CALLBACK
mySubClasshandler(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam){

	switch (msg )
	{
		// only react on messages we know are comming from our server
		case WM_USER + 9999:
			AfxMessageBox("Message from our friend");
			return TRUE;
			break;
		default:
		  return CallWindowProc((WNDPROC)GetProp(hwnd, subclassname),
				 hwnd, msg, wparam, lparam);

	}

}


